<template>

        <el-row :gutter="0">
            <el-col :span="13">
                <h2>
                    {{element.titre}}
                </h2>
            </el-col>
            <el-col :span="9">
                <el-button type="success" :class="{'border-button': btnClique === ValeurA }" circle @click="miseAJourNote( ValeurA, element.ponderation)" @click.stop>{{ ValeurA }}</el-button>
                <el-button type="primary" :class="{'border-button': btnClique === ValeurB }" circle @click="miseAJourNote( ValeurB, element.ponderation)" @click.stop>{{ ValeurB }}</el-button>
                <el-button type="info" :class="{'border-button': btnClique === ValeurC }" circle @click="miseAJourNote( ValeurC, element.ponderation)" @click.stop>{{ ValeurC }}</el-button>
                <el-button type="warning" :class="{'border-button': btnClique === ValeurD }" circle @click="miseAJourNote( ValeurD, element.ponderation)" @click.stop>{{ ValeurD }}</el-button>
                <el-button type="danger" :class="{'border-button': btnClique === ValeurE }" circle @click="miseAJourNote( ValeurE, element.ponderation)" @click.stop>{{ ValeurE }}</el-button>
                <el-button :class="[{'border-button': btnClique === ValeurF}]"   circle @click="miseAJourNote(ValeurF, element.ponderation)" @click.stop>{{ ValeurF }}</el-button>
                <el-button :class="{'border-button': btnClique === NA }" circle @click="miseAJourNote( NA, element.ponderation)" @click.stop>N/A</el-button>
            </el-col>
            <el-col :span="1">
                <div v-if="note !== 9999 ">
                    <h4> {{ note }}</h4>
                </div>
               
            </el-col>

            <el-col :span="1">
                <h3> /{{ element.ponderation }}</h3>
            </el-col>
        </el-row>

</template>

<script lang="ts" setup>

   import { useI18n } from "vue3-i18n"
   import { notifyError } from "@/notify"
   import { Status } from "@/validation"
   import { Element } from "../../types/entities/creation-grille/Element"
   import { notify } from "@kyvg/vue3-notification"
   import { ref, defineProps, defineEmits } from "vue";
import { el } from "element-plus/es/locale"

    interface Notes {
        [key: string]: number;
    }

    // eslint-disable-next-line no-undef
    const props = defineProps<{ element: Element }>();
    // eslint-disable-next-line
    const emit = defineEmits<{ (event: 'noteMiseAJour', note: number, btnClique: number, ponderation: number  ): void }>()


    // Déclaration des constantes
    const ValeurA = 10;
    const ValeurB = 8.5;
    const ValeurC = 7;
    const ValeurD = 6;
    const ValeurE = 4;
    const ValeurF = 0;
    const NA = null;
    let note = ref(9999);
    let btnClique = ref(9999)
    let ponderationRetournee = ref(0);


    function miseAJourNote(valeurNote: number, ponderationElement: number) {

        if (valeurNote == null) {
            note.value = 0;
            btnClique.value = valeurNote
            ponderationRetournee.value = 0;
        }
        else {
            btnClique.value = valeurNote
            let notePondere = (valeurNote / 10) * ponderationElement;
            note.value = formatNumber(notePondere);
            ponderationRetournee.value = ponderationElement;

        }
        emitNoteValue();
    }

    function formatNumber(number: number) {
        if (number % 1 === 0) {
            return number;
        } else {
            return parseFloat(number.toFixed(2));
        }
    }

    function emitNoteValue() {
        emit('noteMiseAJour', note.value, btnClique.value, ponderationRetournee.value);
    }

</script>


    
<style scoped>


    .border-button {
      
        border : 3px solid black;
    }

    .el-card {
        width: 200px;
        margin: 10px;
        text-align: center;
        --el-card-padding: 10px;
    }

    .el-row {
        width: 100%;
    }

    .el-col {
        border-radius: 4px;
    }

    h2, h3, h4 {
        text-align: center;
        margin-top: 10px;
        margin-bottom: 10px;
    }
</style>
